#include <XBee.h>
#include <SoftwareSerial.h>

XBee xbee = XBee();
XBeeResponse response = XBeeResponse();

// create reusable response objects for responses we expect to handle 
Rx64Response rx64 = Rx64Response();

uint8_t option = 0;
uint8_t* data = NULL;
uint8_t* rawData = NULL;

void setup() {
  
  // start serial
  xbee.begin(38400);
  
  Serial.begin(38400);
  
  Serial.println("Arduino. Wait for packets.");

}

// continuously reads packets, looking for RX16 or RX64
void loop() {
    
    Serial.print(".");
    
    xbee.readPacket();
    
    if (xbee.getResponse().isAvailable()) {
      // got something
      
      if (xbee.getResponse().getApiId() == RX_64_RESPONSE) {
        // got a rx packet
        Serial.println("");
        Serial.println("RECEIVED");
        xbee.getResponse().getRx64Response(rx64);
        option = rx64.getOption();
        rawData = rx64.getFrameData();
        data = rx64.getData();

        Serial.println("raw data:");
        Serial.print("Ox");
          
        for (int i=0; i<rx64.getFrameDataLength(); i++) {

          Serial.print(rawData[i], HEX);
          Serial.print(" ");
        }
        
        Serial.println("");
        Serial.println("App data");
        Serial.print("Ox");
          
        for (int i=0; i<rx64.getDataLength(); i++) {

          Serial.print(data[i], HEX);
          Serial.print(" ");
        }
        Serial.println("");
        
        for (int i=0; i<rx64.getDataLength(); i++) {

          Serial.print((char)data[i]);
        }
        
        Serial.println("");
       
      } else if (xbee.getResponse().isError()) {
      //nss.print("Error reading packet.  Error code: ");  
      //nss.println(xbee.getResponse().getErrorCode());
      // or flash error led
      } 
  }
  
  delay(2000);
}
